import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.util.Random;

import org.lekan.graphics.GraphicsProgram;


/**
 * Here's an intro/review to using Java, and an intro to using the SGGraphics package.
 * 
 * Your task: build a simple drawing program that does, at the minimum, the following:
 *  (1) Buttons that lets you choose whether to draw an ellipse, a rectangle, a line, a rounded line, or a quadratic curve
 *  (2) When the program first starts, the main canvas should display a nice welcoming message and/or graphics.
 *  (3) As soon as the user starts drawing, this welcome message should disappear
 *  (4) To draw, click and drag the mouse. The shape should display as you are dragging.
 *  (5) When released, the shape will stay on the screen.
 *  (6) A clear button will clear everything on the screen.
 * 
 * @author Your Name(s) Here!
 *
 */
public class EPGYDraw extends GraphicsProgram {
	public static void main(String[] args) {
		new EPGYDraw();
	}
	
	private boolean moveMode = false;
	private boolean createMode = true;
	private int shapeSet = 0;
	private int clearPlaceholder = 0;
	
	
	@Override
	public void setup() {
		// TODO: SETUP!
		this.getFrame().setTitle("EPGYDraw - Anish Doshi");
	}
	
	/**
	 * Put your program run code here! Most of your code should be in here.
	 */
	@Override
	public void run() {
		this.getFrame().setDimensions(800, 800);
		this.getFrame().drawText("Welcome!", 60, 60);
		this.addButton("Ellipse", NORTH);
		this.addButton("Rectangle", NORTH);
		this.addButton("Line", NORTH);
		this.addButton("Rounded Rectangle", NORTH);
		this.addButton("Clear", SOUTH);
		this.addButton("Create Mode", SOUTH);
		this.addButton("Move Mode", SOUTH);
		
	}
	
	public void actionPerformed (ActionEvent e) {
	
		
		Random generator = new Random();
		if (e.getActionCommand().equals("Rectangle")) {
			if (clearPlaceholder == 0) {
				this.getFrame().clearGraphics();
				clearPlaceholder++;
			}
			if (createMode) {
				this.getFrame().drawRect((generator.nextInt(521)), (generator.nextInt(681)), 60, 30);
			}
			shapeSet = 1;
		}
		if (e.getActionCommand().equals("Line")) {
			if (clearPlaceholder == 0) {
				this.getFrame().clearGraphics();
				clearPlaceholder++;
			}
			if (createMode) {
				this.getFrame().drawLine((generator.nextInt(521)), (generator.nextInt(681)),(generator.nextInt(521)),(generator.nextInt(681)));
			}	
			shapeSet = 2;
		}
		if (e.getActionCommand().equals("Rounded Rectangle")) {
			if (clearPlaceholder == 0) {
				this.getFrame().clearGraphics();
				clearPlaceholder++;
			}
			if (createMode) {
				this.getFrame().drawRoundedRect((generator.nextInt(521)), (generator.nextInt(681)),90, 90);
			}
			shapeSet = 3;
		}	
		if (e.getActionCommand().equals("Ellipse")) {
			if (clearPlaceholder == 0) {
				this.getFrame().clearGraphics();
				clearPlaceholder++;
			}
			if (createMode) {
				this.getFrame().drawEllipse((generator.nextInt(501)), (generator.nextInt(661)), 90, 30);
			}	
			shapeSet = 4;
		}
		if (e.getActionCommand().equals("Clear")) {
			this.getFrame().clearGraphics();
		}	
		if (e.getActionCommand().equals("Move Mode")) {
			moveMode = true;
			createMode = false;
			
		}	
		if (e.getActionCommand().equals("Create Mode")) {
			moveMode = false;
			createMode = true;
			
		}	
		
			
	}
	
	public void mouseDragged (MouseEvent e) {
		
		int lastx = e.getX();
		int lasty = e.getY();
		
		if (moveMode) {	
			
			if(shapeSet == 1) {
				this.getFrame().clearGraphics();
				this.getFrame().drawRect((lastx), (lasty), 60, 30);
			}
			if(shapeSet == 2) {
				this.getFrame().clearGraphics();
				this.getFrame().drawLine((lastx), (lasty), (lastx + 60), (lasty + 30));
			}
			if(shapeSet == 3) {
				this.getFrame().clearGraphics();
				this.getFrame().drawRoundedRect((lastx), (lasty), 60, 30);
			}
			if(shapeSet == 4) {
				this.getFrame().clearGraphics();
				this.getFrame().drawEllipse((lastx), (lasty), 60, 30);
			}
		}
		
		
		
		
	}
	public void mouseReleased (MouseEvent e) {
	
		
		
	}
	
	public void keyReleased(KeyEvent e) {
		
		if (e.getKeyChar() == 'C') {
			moveMode = false;
			createMode = true;
			
		}
		
		if (e.getKeyChar() == 'E') {
			moveMode = false;
			createMode = false;
			
		}
		
		if (e.getKeyChar() == 'M') {
			moveMode = true;
			createMode = false;
			
		}
		
	}
}
